package com.zipcodewilmington.gildedrose;


public class Inventory {
    private Item[] items;

    public Inventory(Item[] items) {
        super();
        this.items = items;
    }
    
    public void updateQuality() {
        for (int i = 0; i < items.length; i++) {

            switch(items[i].getName()){
                case "Aged Brie":
                        updateBrie(items[i]);
                        break;
                case "Backstage passes to a TAFKAL80ETC concert" :
                        updateBackstagePass(items[i]);
                        break;
                case "Sulfuras, Hand of Ragnaros" :
                        updateSulfra(items[i]);
                        break;

                case "Conjured Item" :
                        updateConjure(items[i]);
                        break;
                default :
                        updateDefault(items[i]);
                        break;
            }
        }
    }

    public void updateBrie(Item item){
        if(!sellInExpired(item)){
            incrementQuality(item,1);
        } else{
            incrementQuality(item,2);
        }
        decrementSellIn(item);
    }

    public void updateBackstagePass(Item item){
        if(sellInExpired(item)){
            item.setQuality(0);
        } else if(item.getSellIn() <= 5){
            incrementQuality(item, 3);
        } else if(item.getSellIn() <= 10){
            incrementQuality(item, 2);
        } else{
            incrementQuality(item, 1);
        }
        decrementSellIn(item);
    }

    public void updateSulfra(Item item){
        item.setQuality(80);
        item.setSellIn(item.getSellIn());
    }

    public void updateConjure(Item item){
        incrementQuality(item, -2);
        decrementSellIn(item);
    }

    public void updateDefault(Item item){
        incrementQuality(item, -1);
        decrementSellIn(item);
    }

    public boolean sellInExpired(Item item){
        if(item.getSellIn()<=0){
            return true;
        } else {
            return false;
        }
    }

    public void incrementQuality(Item item, int incr){
        int currentQual = item.getQuality() + incr;
        if(currentQual < 50 && currentQual >= 0) {
            item.setQuality(currentQual);
        } else{
            item.setQuality(50);
        }
    }

    public void decrementSellIn(Item item){
        item.setSellIn(item.getSellIn()-1);
    }
}