package com.zipcodewilmington.gildedrose;

import org.junit.Assert;
import org.junit.Test;

public class InventoryTest {

    @Test
    public void setQualityTest(){
        //Given
        Item rand = new Item("rand", 10, 10);
        int expVal = 42;

        //When
        rand.setQuality(42);

        //Then
        int actVal = rand.getQuality();
        Assert.assertEquals(expVal, actVal);
    }

    @Test
    public void setNameTest(){
        //Given
        Item rand = new Item("rand", 10, 10);
        String expString = "random";

        //When
        rand.setName(expString);

        //Then
        String actString = rand.getName();
        Assert.assertEquals(expString, actString);
    }

    @Test
    public void agedBrie50Quality(){
        //Given
        Item brie = new Item("Aged Brie", 2, 50);
        Item[] items = new Item[1];
        items[0] = brie;
        Inventory inv = new Inventory(items);
        int exp = 50;

        //When
        inv.updateQuality();
        int act = brie.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }


    @Test
    public void agedBrieExpireTest(){
        //Given
        Item brie = new Item("Aged Brie", -1, 39);
        Item[] items = new Item[1];
        items[0] = brie;
        Inventory inv = new Inventory(items);
        int exp = 41;

        //When
        inv.updateQuality();
        int act = brie.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test
    public void passQualityWith5Days(){
        //Given
        Item pass = new Item("Backstage passes to a TAFKAL80ETC concert", 5, 39);
        Item[] items = new Item[1];
        items[0] = pass;
        Inventory inv = new Inventory(items);
        int exp = 42;

        //When
        inv.updateQuality();
        int act = pass.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test
    public void passQualityWith11Days(){
        //Given
        Item pass = new Item("Backstage passes to a TAFKAL80ETC concert", 11, 39);
        Item[] items = new Item[1];
        items[0] = pass;
        Inventory inv = new Inventory(items);
        int exp = 40;

        //When
        inv.updateQuality();
        int act = pass.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test
    public void passQualityWith0Days(){
        //Given
        Item pass = new Item("Backstage passes to a TAFKAL80ETC concert", 0, 39);
        Item[] items = new Item[1];
        items[0] = pass;
        Inventory inv = new Inventory(items);
        int exp = 0;

        //When
        inv.updateQuality();
        int act = pass.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test
    public void passQualityWith10Days(){
        //Given
        Item pass = new Item("Backstage passes to a TAFKAL80ETC concert", 10, 39);
        Item[] items = new Item[1];
        items[0] = pass;
        Inventory inv = new Inventory(items);
        int exp = 41;

        //When
        inv.updateQuality();
        int act = pass.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test
    public void sulfurasTest(){
        //Given
        Item sulfuras = new Item("Sulfuras, Hand of Ragnaros", 17, 80);
        Item[] items = new Item[1];
        items[0] =sulfuras;
        Inventory inv = new Inventory(items);
        int exp = 80;

        //When
        inv.updateQuality();
        int act = sulfuras.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test

    public void conjureTest(){
        //Given
        Item conjure = new Item("Conjured Item", 17, 25);
        Item[] items = new Item[1];
        items[0] = conjure;
        Inventory inv = new Inventory(items);
        int exp = 23;

        //When
        inv.updateQuality();
        int act = conjure.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }

    @Test

    public void defaultTest(){
        //Given
        Item rand = new Item("randName", 17, 25);
        Item[] items = new Item[1];
        items[0] = rand;
        Inventory inv = new Inventory(items);
        int exp = 24;

        //When
        inv.updateQuality();
        int act = rand.getQuality();

        //Then
        Assert.assertEquals(exp, act);
    }
}

